
# coding: utf-8

# In[140]:

from cameo import load_model
from cameo.strain_design.deterministic.flux_variability_based import FSEOF

model2 = load_model ("E:\IGEM\Bioinformatics\gsm\model_yl\MODEL1508190002_bc2g.xml")


# In[141]:

model2.change_objective('2111')
print(model2.objective)
model2.reactions.get_by_id('1714').lower_bound = 0


# In[86]:

for rxn in model2.reactions[-7:-1]:
    print rxn


# In[142]:

model2.reactions.get_by_id('2189').upper_bound =1000
model2.reactions.get_by_id('2189').lower_bound = 0

model2.reactions.get_by_id('1808').lower_bound = -20


# In[143]:

#run fseof
fseof = FSEOF(model2)
target = 'DM_bcarotene'
result = fseof.run(target=model2.reactions.get_by_id(target))

#check to see if product increase from 10 -0 , or if its reversed, reversed is true, if product decrease from 10 to 1
reverse = False  
if result.data_frame.values[-1][-1] >  result.data_frame.values[-1][0]:
    reverse = True


# In[144]:

#define dictionary - rseof_verdict , keys are rxn, values are 'increasing', 'decreasing', 'unchanged'
#where increasing means the values are increasing, in the direciton of the prodcut increasing.

keys = []
values = []


ind = -1
for rxn in result.data_frame.T:
    
    ind = ind + 1
    #print (ind, 'out of', len(result.data_frame) - 1)

    keys.append(rxn)
    
    if abs( result.data_frame.values[ind][0]) > abs (result.data_frame.values[ind][-1]) :
        if reverse == True:
            values.append('decreasing')
        elif reverse == False:    
            values.append('increasing')
    
    elif abs( result.data_frame.values[ind][0]) < abs (result.data_frame.values[ind][-1]):
        if reverse == True:
            values.append('increasing')
        elif  reverse == False:    
            values.append('decreasing')
    elif abs( result.data_frame.values[ind][0]) == abs (result.data_frame.values[ind][-1]):
        values.append('unchanged')


rseof_verdict = dict(zip(keys, values))


# In[145]:

#define dicitonary - rseof,  where keys are 'increasing', 'decreasing', 'unchanged', and values are rxns
#define dictionary - rxn_b, where keys are rxn and values are maxm theretical flux
#define dictionary - gene_b, where keys are genes and values are maxm theretical flux

key_rxn_b = []
value_rxn_b = []    

rseof = {'increasing': [], 'decreasing': [], 'unchanged': []}

ind = -1

for rxn in result.data_frame.T:
   
    ind = ind + 1
    print (ind, 'out of', len(result.data_frame) - 1)
    
    if abs( result.data_frame.values[ind][0]) > abs (result.data_frame.values[ind][-1]) :
        if reverse == True:
            rseof['decreasing'].append(rxn)
        elif reverse == False:
            rseof['increasing'].append(rxn)
    
    elif abs( result.data_frame.values[ind][0]) < abs (result.data_frame.values[ind][-1]):
        if reverse == True:
            rseof['increasing'].append(rxn)
        elif reverse == False:    
            rseof['decreasing'].append(rxn)
    
    elif abs( result.data_frame.values[ind][0]) == abs (result.data_frame.values[ind][-1]):
        rseof['unchanged'].append(rxn)
        
    key_rxn_b.append(rxn)
    if reverse == True:
        value_rxn_b.append(result.data_frame.values[ind][-1])
    elif reverse == False:
        value_rxn_b.append(result.data_frame.values[ind][0])


rxn_b = dict(zip(key_rxn_b, value_rxn_b)) #dictionary that keys rxn to get value of max theoritacl flux

key_gene_b =[]
for rxn in key_rxn_b:
    key_gene_b.append( model2.reactions.get_by_id(rxn).gene_reaction_rule)

gene_b = dict(zip(key_gene_b, value_rxn_b)) #dictionary that keys gene to get value of max theoritacl flux


# In[146]:

#find all the genes that can be amplified to optimize target flux
genes_can_be_amp = []
rxn_can_be_amp = []
for rxn in rseof['increasing']:
    if bool(model2.reactions.get_by_id(rxn).gene_reaction_rule):
        genes_can_be_amp.append(model2.reactions.get_by_id(rxn).gene_reaction_rule)
        rxn_can_be_amp.append(rxn)
        


# In[147]:

##SAVE THIS GENE YALI0E09603g #make 2-oxygluatate stay in citric acid cycle -gdha

print (reverse, 'YALI0E09603g' in genes_can_be_amp) #make 2-oxygluatate stay in citric acid cycle -gdha


# In[148]:

#check that FSEOF works by implementing the amplifications
model3 = model2.copy()
model3.change_objective('2111')
for rxn in rxn_can_be_amp:
    if rxn != target:
        if rxn_b[rxn] < 0:
            model3.reactions.get_by_id(rxn).upper_bound = rxn_b[rxn] * 0.8
        elif rxn_b[rxn] > 0:
            model3.reactions.get_by_id(rxn).lower_bound = rxn_b[rxn] * 0.8
        #print(rxn, rxn_b[rxn])

sol2 = model2.solve()
sol3 = model3.solve()
print('model2 vs model3 (enforced), growth rate', sol2.fluxes['2111'], sol3.fluxes['2111'])
print('model2 vs model3 (enforeced), bcarotene flux', sol2.fluxes['DM_bcarotene'], sol3.fluxes['DM_bcarotene'])


# In[149]:

result.data_frame.to_csv("E:\IGEM\Bioinformatics\gsm\LOOKHERE_glyc2g\LOOKHERE_glyc2g.csv")


# In[16]:

##### NOT USED ############

#dictionary inc_rxn_grad has keys as rxn that is increasing, and values as the gradient of increasing, here -ve gradient means increasing in the -ve direction
#dictionary dec_rxn_grad has keys as rxn that is decreasing, and values as the gradient of decreasing. 
# when comparing or sorting, use abs to disregard direciton of reaction. i.e. use inc_rxn_grad_abs and dec_rxn_grad_abs

ind = -1
inc_key = []
inc_val = []
dec_key = []
dec_val = []

inc_val_abs= []
dec_val_abs = []

for rxn in result.data_frame.T:
    ind = ind + 1
    
    if rseof_verdict[rxn] == 'increasing':
        inc_key.append(rxn)
        grad = (result.data_frame.values[ind][-1] - result.data_frame.values[ind][0]) / 10
        inc_val.append(grad)
        inc_val_abs.append(abs(grad))
    elif rseof_verdict[rxn] == 'decreasing':
        dec_key.append(rxn)
        grad = (result.data_frame.values[ind][0] - result.data_frame.values[ind][-1]) / 10
        dec_val.append(grad)
        dec_val_abs.append(abs(grad))

inc_rxn_grad = dict(zip(inc_key, inc_val))
dec_rxn_grad = dict(zip(dec_key, dec_val))

inc_rxn_grad_abs = dict(zip(inc_key, inc_val_abs))
dec_rxn_grad_abs = dict(zip(dec_key, dec_val_abs))


# In[150]:

import xlrd
inc_rxn_grad2_abs = {}
dec_rxn_grad2_abs = {}

inc_key2 = []
dec_key2 = []

inc_val_abs2= []
dec_val_abs2 = []

#craet dictionary fseof_all_grad2  keys as fseof rxn names, values as grad2 - calculated by R
#craet dictionary fseof_all_grad2_abs  keys as fseof rxn names, values as abs(grad2) - calculated by R
fseof_all_grad2={}
fseof_all_grad2_abs={}

wb = xlrd.open_workbook('E:\\IGEM\\Bioinformatics\\gsm\\LOOKHERE_glyc2g\\fseof_all.xlsx')
sh = wb.sheet_by_index(0)   
for i in range(1,108):
    rxn_key2 = sh.cell(i,1).value
    rxn_value2 = sh.cell(i,14).value
    fseof_all_grad2[rxn_key2] = rxn_value2
    fseof_all_grad2_abs[rxn_key2] = abs(rxn_value2)

    
    
#creat list of danger rxns, these rxn fluxes do not linearly change as we move up produciton envelope. trehslhold r2 is 0.9
danger_rxn_list = []
wb1 = xlrd.open_workbook('E:\\IGEM\\Bioinformatics\\gsm\\LOOKHERE_glyc2g\\fseof_danger.xlsx')
sh1 = wb1.sheet_by_index(0)  
for i in range(1, 84):
    danger_rxn_list.append(sh1.cell(i,1).value) #reasionably linear with one or two outliers so ok to use grad
    

    
#create dictionary inc_rxn_grad2_abs, keys as rxns that are increasing, velues as abs(grad2) calculated from R
#create dictionary dec_rxn_grad2_abs, keys as rxns that are increasing, velues as abs(grad2) calculated from R
for rxn in fseof_all_grad2.keys():
    if rseof_verdict[rxn] == 'increasing':
        inc_key2.append(rxn)
        inc_val_abs2.append(fseof_all_grad2_abs[rxn])
    elif rseof_verdict[rxn] == 'decreasing':
        dec_key2.append(rxn)
        dec_val_abs2.append(fseof_all_grad2_abs[rxn])

inc_rxn_grad2_abs = dict(zip(inc_key2, inc_val_abs2))
dec_rxn_grad2_abs = dict(zip(dec_key2, dec_val_abs2))


# In[151]:

import operator

sorted_inc_rxn_grad2_abs = sorted(inc_rxn_grad2_abs.items(), key=operator.itemgetter(1), reverse=True)
sorted_dec_rxn_grad2_abs = sorted(dec_rxn_grad2_abs.items(), key=operator.itemgetter(1), reverse=True)


# In[18]:

## NOT USED
sorted_inc_rxn_grad_abs = sorted(inc_rxn_grad_abs.items(), key=operator.itemgetter(1), reverse=True)
sorted_dec_rxn_grad_abs = sorted(dec_rxn_grad_abs.items(), key=operator.itemgetter(1), reverse=True)


# In[64]:

model4 = model2.copy()
model4.change_objective('2111')
sol4 = model4.solve()
print (sol4.fluxes['DM_bcarotene'])

i = 105
rxn = sorted_inc_rxn_grad2_abs[i][0]
if rxn_b[rxn] < 0:
    model4.reactions.get_by_id(rxn).upper_bound = rxn_b[rxn] * 1
elif rxn_b[rxn] > 0:
    model4.reactions.get_by_id(rxn).lower_bound = rxn_b[rxn] * 1
    
sol4 = model4.solve()
sol4.fluxes['DM_bcarotene']


# In[20]:

model4.reactions.get_by_id('525')


# In[152]:

model4 = model2.copy()
model4.change_objective('2111')

candidate_rxn= []
candidate_score = []
select_rxn = {}

for i in range (0,len(sorted_inc_rxn_grad2_abs)):
    print (i, 'out of', len(sorted_inc_rxn_grad2_abs) - 1)
    model4 = model2.copy()
    model4.change_objective('2111')
    rxn = sorted_inc_rxn_grad2_abs[i][0]
    if rxn_b[rxn] < 0:
        model4.reactions.get_by_id(rxn).upper_bound = rxn_b[rxn] * 1
    elif rxn_b[rxn] > 0:
        model4.reactions.get_by_id(rxn).lower_bound = rxn_b[rxn] * 1
    #print(rxn, rxn_b[rxn])


    sol44 = model4.solve()
    if sol44.fluxes['DM_bcarotene'] - 0 > 0.0001:
        print (i,rxn, sol44.fluxes['DM_bcarotene'])
        candidate_rxn.append(rxn)
        candidate_score.append(sol44.fluxes['DM_bcarotene'])
        select_rxn[rxn] = sol44.fluxes['DM_bcarotene']
## down regulating genes have no effect
#for i in range (0,len(sorted_dec_rxn_grad2_abs)):
 #   rxn1 = sorted_dec_rxn_grad_abs[i][0]
  #  if rxn_b[rxn1] < 0:
   #     model4.reactions.get_by_id(rxn1).lower_bound = rxn_b[rxn1] * 1
    #elif rxn_b[rxn1] > 0:
     #   model4.reactions.get_by_id(rxn1).upper_bound = rxn_b[rxn1] * 1
    ##print(rxn, rxn_b[rxn])                
    

sol2 = model2.solve()
sol4 = model4.solve()
print('model2 vs model4 (enforced), growth rate', sol2.fluxes['2111'], sol4.fluxes['2111'])
print('model2 vs model4 (enforeced), bcarotene flux', sol2.fluxes['DM_bcarotene'], sol4.fluxes['DM_bcarotene'])


# In[98]:

###NOT USED
model4 = model2.copy()
model4.change_objective('2111')

candidate_rxn= []
candidate_score = []
select_rxn = {}

# down regulating genes have no effect
for i in range (0,len(sorted_dec_rxn_grad2_abs)):
    print (i, 'out of', len(sorted_dec_rxn_grad2_abs) - 1)
    rxn1 = sorted_dec_rxn_grad2_abs[i][0]
    if rxn_b[rxn1] < 0:
        model4.reactions.get_by_id(rxn1).lower_bound = rxn_b[rxn1] * 1
    elif rxn_b[rxn1] > 0:
        model4.reactions.get_by_id(rxn1).upper_bound = rxn_b[rxn1] * 1
    ##print(rxn, rxn_b[rxn])     
    
    sol44 = model4.solve()
    if sol44.fluxes['DM_bcarotene'] - 0 > 0.001:
        print (i,rxn, sol44.fluxes['DM_bcarotene'])
        candidate_rxn.append(rxn)
        candidate_score.append(sol44.fluxes['DM_bcarotene'])
        select_rxn[rxn] = sol44.fluxes['DM_bcarotene']


# In[153]:

select_rxn


# In[154]:

select_genes = []
for rxn in candidate_rxn:
    if not(not(model2.reactions.get_by_id(rxn).gene_reaction_rule)):
    
        select_genes.append ( model2.reactions.get_by_id(rxn).gene_reaction_rule)


# In[139]:

#select_genes.to_csv("E:\IGEM\Bioinformatics\gsm\LOOKHERE_oleic\selected_genes_to_amp.csv")


outfile = open("E:\IGEM\Bioinformatics\gsm\LOOKHERE_oleic\selected_genes_to_amp.txt", 'w')
for i in select_genes:
    print(i)
    outfile.write(i)


# In[27]:

# from final_rrxn_to_amp- list of rxn to amplify, find what genes are asssociated with it (final_genes_to_amp), and...
#what reaction bounds shoudl we amp it to (bound), ie. the flux in rxn_b
final_rrxn_to_amp = []
final_genes_to_amp = []
#the reaactions are not in teh danger list green light
final_rrxn_to_amp.append('217')
final_rrxn_to_amp.append('1118')
final_rrxn_to_amp.append('2132')

bounds = []

for r in final_rrxn_to_amp:
    bounds.append(rxn_b[r])
    final_genes_to_amp.append(model22.reactions.get_by_id(r).gene_reaction_rule) 


# In[147]:

final_genes_to_amp


# In[155]:

fseof_all_grad2_4cytoscpae = fseof_all_grad2.copy()
for rxn in fseof_all_grad2_4cytoscpae.keys():
    fseof_all_grad2_4cytoscpae['R_' + rxn] = fseof_all_grad2_4cytoscpae.pop(rxn)
    
    


# In[156]:

#output gradient to plot in cytoscape
import csv
with open('E:\IGEM\Bioinformatics\gsm\LOOKHERE_glyc2g\cytoscope_rxn_grad2.csv','wb') as f:
    w = csv.writer(f)
    w.writerows(fseof_all_grad2_4cytoscpae.items())


# In[158]:

fseof_all_grad2_4cytoscpae


# In[237]:

result


# In[166]:

for rxn in select_rxn:
    print (model2.reactions.get_by_id(rxn).name)


# In[ ]:



