#this code reads in the reaction and uptake rates as we move up production evelope, and evaluate
#if it is dangerous to assume the reaction flux change to be linear, setting R2 of 0.9. The gradient
#is then calculate for each reaction.

library(xlsx)


fseof = read.csv("E:/IGEM/Bioinformatics/gsm/LOOKHERE_oleic/LOOKHERe_oleic.csv")

rownames(fseof) = fseof[1][,]
colnames(fseof) <- c ('rxn', '1','2','3','4','5','6','7','8','9','10')

for (n in rownames(fseof)){

  fseof[n, "grad"] <- (fseof[n, "9"] - fseof[n, "1"])/9
  
}

row.names(fseof)[order(-fseof$grad)]

m = dim(fseof)[1]
r2 = numeric(m)
grad2 = numeric(m)
x = 1:10

for(i in 1:m){
  r2[i] = summary(lm(t(fseof[i,2:11])~x))$adj.r.squared
  grad2[i] = lm(t(fseof[i,2:11])~x)$coefficients[2]
}

fseof_danger <- cbind(fseof[r2<0.9,],r2[r2<0.9], grad2[r2<0.9])
fseof_ok <- cbind(fseof[r2>0.9,],r2[r2>0.9], fseof$grad[r2>0.9], grad2[r2>0.9])
fseof <- cbind(fseof,r2, grad2)

write.xlsx(fseof, "E:/IGEM/Bioinformatics/gsm/LOOKHERE_oleic/fseof_all.xlsx")
write.xlsx(fseof_ok, "E:/IGEM/Bioinformatics/gsm/LOOKHERE_oleic/fseof_ok.xlsx")
write.xlsx(fseof_danger, "E:/IGEM/Bioinformatics/gsm/LOOKHERE_oleic/fseof_danger.xlsx")


