clear all;
initCobraToolbox;
changeCobraSolver('glpk', 'LP');

%% test on ecoli model form tutorial
run_tutor = 0;
if run_tutor == 1
    model=readCbModel('ecoli_textbook');
    
    model = changeObjective(model,'Biomass_Ecoli_core_N(w/GAM)_Nmet2');
    
    model = changeRxnBounds(model,'EX_glc(e)', 0,'l');
    model = changeRxnBounds(model,'EX_o2(e)',0,'l');
    model = changeRxnBounds(model,'EX_ac(e)',-20,'l');
    
    sol =  optimizeCbModel(model, 'max')
end
%%  
%run yarrowia model

modelFile = 'E:\IGEM\Bioinformatics\gsm\model_yl\MODEL1508190002_bc3';
model0=readCbModel(modelFile);

%define metabolites of interest
% met_glc = 'glc_D_v[Cytosol]';
% met_ac = 'ac_e[Cytosol]';
% met_o2 =  'o2_e[Cytosol]';
% met_glyc = 'glyc_c[Extra_organism]';
% met_farnesyl = 'frdp_c[Cytosol]';
met_glc = 'm511[ex]';
met_o2 = 'm1339[ex]';
met_glyc = 'm1056[ex]';
met_farnesyl = 'm512[cy]';
met_fructose = 'm963[ex]';
met_xylose= 'm1205[ex]';
met_maltose= 'm1322[ex]';
met_sucrose= 'm962[ex]';
met_oleate= 'm1463[ex]';
met_epolyol = 'm1826[ex]';


%define exxhange (uptake) reactions to change uptake flux bounds, these are
%consistent across text_book and ecoli1 models
% rxn_glc = 'EX_glc(e)';
% rxn_ac = 'EX_ac(e)';
% rxn_o2 = 'EX_o2(e)';
% rxn_glyc = 'EX_glyc(e)';
% rxn_farnesul = 'GRTT';
% rxn_lip = 'exlip';
rxn_glc = '1714';
rxn_glyc = '1808';
rxn_o2 = '1992';
rxn_farnesyl = '462'; %('geranyltranstransferase')
rxn_biomass = '2111'; %growth
rxn_squalene = '1012'; %squalene  synthase
rxn_gerger = '373'; %make geranylgeranyl farnesyltranstransferase
rxn_pentapreny = '461'; %make pentapreny 
rxn_pentapreny_transport = '1242';
rxn_far_transport = '1766';
rxn_lip = '2108'; %lipid suedoreacion
rxn_amonium = '1654'; %nitrogen amomium source(exhange)
rxn_bcarotene = 'DM_bcarotene'; %beta-carotene drain
rxn_fructose = model0.rxns(find(strcmp(model0.rxnNames, 'D-fructose exchange')));
rxn_sucrose = model0.rxns(find(strcmp(model0.rxnNames, 'sucrose exchange')));
rxn_maltose = model0.rxns(find(strcmp(model0.rxnNames, 'maltose exchange')));
rxn_xylose = model0.rxns(find(strcmp(model0.rxnNames, 'D-xylose exchange')));
rxn_oleate = model0.rxns(find(strcmp(model0.rxnNames, 'oleate exchange')));
rxn_epolyol = 'yli0041';
rxn_mpolyol = 'yli0043';
rxn_apolyol = '1876';

%model0 = model1;
%set onjective euqaion
%model0 = changeObjective(model0, model0.rxns(end-7));
%model0 = changeObjective(model0, 'GRTT');
%model0 = changeObjective(model0, rxn_lip);
%mode10 = changeObjective(model0, rxn_biomass, 1);

model0 = changeObjective(model0, 'DM_bcarotene', 1)
%define what to phpp test
rxn1 = rxn_glyc;
met1 = met_glyc;
%rxn2 = rxn_glyc;
%met2 = met_glyc;
rxn2 = rxn_o2;
met2 = met_o2;


%change other nutrients to zero uptake
%model0 = changeRxnBounds(model0,rxn_ac, 0,'l');
model0 = changeRxnBounds(model0,rxn_glc, 0,'b');
model0 = changeRxnBounds(model0,rxn_glyc, 0,'b');
model0 = changeRxnBounds(model0,rxn_fructose, 0,'b');
model0 = changeRxnBounds(model0,rxn_sucrose, 0,'b');
model0 = changeRxnBounds(model0,rxn_xylose, 0,'b');
model0 = changeRxnBounds(model0,rxn_maltose, 0,'b');
model0 = changeRxnBounds(model0,rxn_oleate, 0,'b');
%model0 = changeRxnBounds(model0, rxn_amonium, -0.01, 'b');

%phpp analysis
num = 50; % num of uptake flux points examined
sp_g = zeros(num); %shadow prices regard to metabolite 1
sp_o = zeros(num); %shadow prices regard to metabolite 2
gr = zeros(num); %growth rate
squalene = zeros(num);
gerger = zeros(num);
bcarotene = zeros(num);
solf = zeros(num);%optimal solution of the objective funciotn
lip = zeros(num); % lipids extracellualr
stats = zeros(num); %stats, 1 is good, zeros are infeasibel
epolyol = zeros(num);
mpolyol = zeros(num);

%model0 = changeObjective(model0, rxn_lip);
%model0 = changeRxnBounds(model0,rxn_lip, 1000,'u');
%model0 = changeRxnBounds(model0,'1012', 0.02,'u');
%model0 = changeRxnBounds(model0,rxn_farnesyl, 0.02,'l');
%model0 = changeRxnBounds(model0,'1766', 0,'u');
unit = linspace(0, 20, num);
for g = 1:length(unit)
    g
    for o = 1: length(unit)
        model0 = changeRxnBounds(model0,rxn1, -1* unit(g),'b');
        model0 = changeRxnBounds(model0,rxn2, -1* unit(o),'b');
        %maintenance ATPM
       % mantainance = g *  2.;
        %model0 = changeRxnBounds (model0, 'ATPM', mantainance, 'b');

        sol =  optimizeCbModel(model0, 'max');
        
        stats(g, o) = sol.stat;
        
        if sol.stat ~= 1
            sp_g(g, o) = 0;
            sp_o(g, o) = 0;
            gr(g,o) = 0;
            solf(g,o) = 0;
            lip(g,o) = 0;
            bcarotene(g,o) = 0;
            epolyol(g,o) = 0;
            mpolypol(g,o) = 0;
        else
            sp_g(g, o) = sol.y(find(strcmp(model0.mets, met1)));
            sp_o(g, o) = sol.y(find(strcmp(model0.mets, met2)));
            gr(g,o) = sol.x(find(strcmp(model0.rxns, rxn_biomass)));
            solf(g,o) = sol.x(find(strcmp(model0.rxns, rxn_farnesyl)));
            gerger(g,o) = sol.x(find(strcmp(model0.rxns, rxn_gerger)));
            squalene(g,o) = sol.x(find(strcmp(model0.rxns, rxn_squalene)));
            lip(g,o) = sol.x(find(strcmp(model0.rxns, rxn_lip)));
            bcarotene(g,o) = sol.x(find(strcmp(model0.rxns, rxn_bcarotene)));
            epolyol(g,o) = sol.x(find(strcmp(model0.rxns, rxn_epolyol)));
            mpolyol (g,o) = sol.x(find(strcmp(model0.rxns, rxn_mpolyol)));
            apolyol (g,o) = sol.x(find(strcmp(model0.rxns, rxn_apolyol)));
        end
    end
end
% 
% figure(1)
% surf(flipud(sp_g)) %shadow prices regard to met1
% figure(2)
% surf(flipud(sp_o)) %shadow price regard to met2
% figure(3)
% surf(flipud(gr)) % growth rate
% figure(4)
% surf(flipud(stats)) %where solutions are feasibel or not

figure(1)
imagesc(flipud(sp_g), [-0.004, 0.04]) %shadow prices regard to met1
xlabel(strcat('O2 uptake rate', ' [mmol/gDW/hr]'))
ylabel(strcat('Glycerol uptake rate', ' [mmol/gDW/hr]'))
title(sprintf('shadow prices of biomass to %s', 'Glycerol'), 'FontSize', 30)
colorbar
c = colorbar;
ylabel(c, 'shadow price [mmol/gDW/hr/hr]', 'FontSize', 18)
set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)), 'FontSize', 18);
set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)), 'FontSize', 18);
axis square


figure(2)
axis square
imagesc(flipud(sp_o), [-0.01, 0.01]) %shadow price regard to met2
xlabel(strcat('O2 uptake rate', ' [mmol/gDW/hr]'))
ylabel(strcat('Glycerol uptake rate', ' [mmol/gDW/hr]'))
title(sprintf('shadow prices of biomass to %s', 'O2'), 'FontSize', 30)
colorbar
c = colorbar;
ylabel(c, 'shadow price [mmol/gDW/hr/hr]', 'FontSize', 18)
set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)), 'FontSize', 18);
set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)), 'FontSize', 18);
axis square

figure(3)
axis square
imagesc(flipud(gr)) % growth rate
xlabel(strcat('O2 uptake rate', ' [mmol/gDW/hr]'))
ylabel(strcat('Glycerol uptake rate', ' [mmol/gDW/hr]'))
title('growth rate [/hr]', 'FontSize', 30)
colorbar
c = colorbar;
ylabel(c, 'growth rate (/hr)', 'FontSize', 18)
set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)), 'FontSize', 18);
set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)), 'FontSize', 18);
axis square

figure(4)
imagesc(flipud(solf)) % growth rate
xlabel(strcat('O2 uptake rate', '[mmol/gDW/hr]'))
ylabel(strcat('Glycerol uptake rate', '[mmol/gDW/hr]'))
title('farnesyl rate [mmol/gDW/hr]', 'FontSize', 30)
colorbar
c = colorbar;
ylabel(c, 'farnesyl rate [mmol/gDW/hr]', 'FontSize', 18)
set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)), 'FontSize', 18);
set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)), 'FontSize', 18);
axis square
% 
% figure(5)
% imagesc(flipud(gerger)) % growth rate
% xlabel(strcat(met2, '[mmol/gDW/hr]'))
% ylabel(strcat(met1, '[mmol/gDW/hr]'))
% title('gerger rate [mmol/gDW/hr]', 'FontSize', 30)
% colorbar
% set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)), 'FontSize', 18);
% set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)), 'FontSize', 18);

figure(6)
axis square
imagesc(flipud(stats)) %where solutions are feasibel or not
xlabel(strcat('O2 uptake rate', ' [mmol/gDW/hr]'))
ylabel(strcat('Glycerol uptake rate', ' [mmol/gDW/hr]'))
title('Feasible solution space has values 1', 'FontSize', 30)
colorbar
set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)), 'FontSize', 18);
set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)), 'FontSize', 18);
axis square

% figure(7)
% imagesc(flipud(squalene)) % growth rate
% xlabel(strcat(met2, '[mmol/gDW/hr]'))
% ylabel(strcat(met1, '[mmol/gDW/hr]'))
% title('squalene rate [mmol/gDW/hr]')
% colorbar
% set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)));
% set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)));
% 
% figure(8)
% imagesc(flipud(lip)) % growth rate
% xlabel(strcat(met2, '[mmol/gDW/hr]'))
% ylabel(strcat(met1, '[mmol/gDW/hr]'))
% title('lip rate [mmol/gDW/hr]')
% colorbar
% set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)));
% set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)));

figure(9)
imagesc(flipud(bcarotene)) % growth rate
xlabel(strcat('O2 uptake rate', ' [mmol/gDW/hr]'))
ylabel(strcat('Glycerol uptake rate', ' [mmol/gDW/hr]'))
title('beta-carotene product flux [mmol/gDW/hr]', 'FontSize', 30)
colorbar
c = colorbar;
ylabel(c, 'beta-carotene product flux [mmol/gDW/hr]', 'FontSize', 18)
set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)), 'FontSize', 18);
set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)), 'FontSize', 18);
axis square

figure(10)
surf(gr) % growth rate
xlabel(strcat('O2 uptake rate', ' [mmol/gDW/hr]'))
ylabel(strcat('glycerol uptake rate', ' [mmol/gDW/hr]'))
title('rowth rate [/hr]', 'FontSize', 30)
colorbar
c = colorbar;
ylabel(c, 'beta-carotene product flux [mmol/gDW/hr]', 'FontSize', 16)
set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)), 'FontSize', 16);
set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)), 'FontSize', 16);
axis square

% 
% figure(10)
% imagesc(flipud(apolyol)) % growth rate
% xlabel(strcat(met2, '[mmol/gDW/hr]'))
% ylabel(strcat(met1, '[mmol/gDW/hr]'))
% title('apolyol [mmol/gDW/hr]')
% colorbar
% set(gca,'YTick',linspace(0,num, num/5), 'YTickLabel', round(linspace(20,0,num/5)));
% set(gca,'XTick',linspace(0,num, num/5),  'XTickLabel', round(linspace(0,20,num/5)));